﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Dim rp As RuntimePermissions
	
	Private zx1 As ZxingBarcodeScanner
	Private b1 As Button
	Private b2 As Button
	Private b3 As Button
	
	Public l1 As Label
	
	Dim flag As Int = 0
	Dim runningavg As Int = 127
	
	Public l2 As Label
	Private l3 As Label
	Private b4 As Button
	Private b5 As Button
	
	Dim scanStarted As Boolean = False
	
	Dim page2 As B4XPage2
	


End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("Main")

	
	page2.Initialize
	B4XPages.AddPage("Page 2", page2)
	
	Dim Result As Boolean = True
	If Not(rp.Check(rp.PERMISSION_CAMERA)) Then
		rp.CheckAndRequest(rp.PERMISSION_CAMERA)
		Wait For B4XPages_PermissionResult (Permission As String, Result As Boolean)
	End If
	If Result Then
	
'		nativeMe.InitializeContext
		
		l3.Text = ""
		zx1.LaserColor = Colors.Yellow
		zx1.MaskColor = Colors.ARGB(150, 0, 0, 200)
		zx1.BorderColor = Colors.Magenta
		zx1.BorderStrokeWidth = 5
		zx1.BorderLineLength = 40
		
		zx1.AutoFocusInterval = 500
		zx1.AutoFocus = True
		zx1.FocusMode = zx1.FOCUS_MODE_AUTO
		
		
		
		zx1.Visible = False
		
	Else
		ToastMessageShow("Permission not granted", True)
		Return
	End If
	
	
	
End Sub

Sub  B4XPage_Disappear
	
	
End Sub

Sub b1_Click
	
	zx1.toggleFlash
	
End Sub

Sub b2_Click
   
	zx1.Visible = True
	zx1.startScanner
	zx1.TurnFlashOn
	scanStarted = True
	Log(zx1.isFlashOn)
   
End Sub

Sub b3_Click
	
	scanStarted = False
	zx1.Visible = False
	zx1.stopScanner
	l1.Text = ""
	l2.Text = ""

End Sub

Sub b4_Click
	
	Dim zoomInValue As Int = 5                     'positive values -> zoon in
	If scanStarted Then
		If zx1.CurrentZoomValue <= (zx1.MaxZoomValue - zoomInValue) Then
			zx1.zoomIn(zoomInValue)
		Else
			zx1.zoomIn(zx1.MaxZoomValue - zx1.CurrentZoomValue)
		End If
	End If
	
End Sub

Sub b5_Click
	
	Dim zoomInValue As Int = -5                     'negative values -> zoom out
	If scanStarted Then
		If zx1.CurrentZoomValue > (-1* zoomInValue) Then
			zx1.zoomIn(zoomInValue)
		Else
			zx1.zoomIn(0 - zx1.CurrentZoomValue)
		End If
	End If
	
End Sub

Sub zx1_scan_result (scantext As String, scanformat As String)
	
	Log ("B4A scan text = " & scantext)
	Log ("B4A scan format = " & scanformat)
	Log("isFlashOn = " & zx1.isFlashOn)
	l2.Text = scantext & CRLF & "Type = " & scanformat
	
	zx1.Visible = False
	zx1.stopScanner
	B4XPages.ShowPage("Page 2")
	
End Sub


Sub zx1_brightness_changed (bright As Int )                        'ADDED 6 MARCH 2016
'	Log("bright = " & bright)                                      'this is the average brightness of the frame that was captured for possible barcode extraction
	flag = flag + 1
	l1.Text = "Brigtness = " & bright
	If flag = 30 Then                                              'I only want to use the average brightness of every 30th frame to calculate a running brigtness average
		flag = 0                                                   'reset the count to zero for the next 30 frames
		If bright < 150 Then                                       'discard excessive high brigness values
			runningavg = (runningavg + bright) / 2
'			Log("runningavg brightness = " & runningavg)
			If runningavg < 70 Then
				If Not(zx1.isFlashOn) Then zx1.TurnFlashOn
			Else if runningavg > 115 Then
				If zx1.isFlashOn Then zx1.TurnFlashOff
			End If
		End If
	End If
	l3.Text = "isFlashOn = " & zx1.isFlashOn
	
End Sub

